// Package etcd...
//
// Description : etcd...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2021-11-23 12:27 下午
package etcd

import (
	"fmt"
	"testing"

	"git.zhangdeman.cn/zhangdeman/gopkg/util"

	"go.etcd.io/etcd/clientv3"
)

func init() {
	err := InitEtcdClient(clientv3.Config{
		Endpoints: []string{"localhost:2379"},
	})
	if nil != err {
		panic(err.Error())
	}
}

// TestPut ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 12:27 下午 2021/11/23
func TestPut(t *testing.T) {
	fmt.Println(Put(nil, "name", "zhangdeman", 0))
}

// TestGet ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 12:30 下午 2021/11/23
func TestGet(t *testing.T) {
	fmt.Println(Get(nil, "name", 0))
}

// TestGetWithPrefix 根据key前缀读取数据
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 11:01 上午 2021/11/24
func TestGetWithPrefix(t *testing.T) {
	prefix := "/test/dir/"
	for i := 0; i < 10; i++ {
		_ = Put(nil, fmt.Sprintf("%s%d", prefix, i), util.GenRandomString("", 8), 0)
	}
	fmt.Println(GetWithPrefix(nil, prefix, 0))
}
